Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/EngineBase.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/EngineBase.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/EngineBase.cs	(revision 2027)
@@ -188,5 +188,5 @@
       myExecutionStack.Clear();
       if (OperatorGraph.InitialOperator != null)
-        myExecutionStack.Push(new AtomicOperation(OperatorGraph.InitialOperator, GlobalScope));
+        myExecutionStack.Push(new AtomicOperation(OperatorGraph.InitialOperator, new Environment(), GlobalScope));
       OnInitialized();
     }
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Environment.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Environment.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Environment.cs	(revision 2027)
@@ -27,15 +27,19 @@
 namespace HeuristicLab.Core {
   public class Environment : ItemBase, IEnvironment {
-    private Environment parent;
+    private IEnvironment parent;
+    private Dictionary<string, string> aliases;
 
     /// <summary>
     /// Initializes a new instance of <see cref="Environment"/>.
     /// </summary>
-    public Environment() { }
+    public Environment() {
+      aliases = new Dictionary<string, string>();
+    }
     /// <summary>
     /// Initializes a new instance of <see cref="Environment"/> with the given <paramref name="parent"/>.
     /// </summary>
     /// <param name="parnet">The parent environment.</param>
-    public Environment(Environment parent) {
+    public Environment(IEnvironment parent)
+      : this() {
       this.parent = parent;
     }
@@ -51,6 +55,22 @@
       Environment clone = new Environment();
       clonedObjects.Add(Guid, clone);
-      clone.parent = (Environment)Auxiliary.Clone(parent, clonedObjects);
+      clone.parent = (IEnvironment)Auxiliary.Clone(parent, clonedObjects);
       return clone;
+    }
+
+    public void AddAlias(string oldName, string newName) {
+      aliases.Add(oldName, newName);
+    }
+    public void RemoveAlias(string name) {
+      aliases.Remove(name);
+    }
+
+    public string TranslateName(string name) {
+      string translatedName = name;
+      if (aliases.ContainsKey(translatedName))
+        translatedName = aliases[translatedName];
+      if (parent != null)
+        translatedName = parent.TranslateName(translatedName);
+      return translatedName;
     }
 
@@ -83,5 +103,5 @@
     public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
       base.Populate(node, restoredObjects);
-      parent = (Environment)PersistenceManager.Restore(node.SelectSingleNode("ParentEnvironment"), restoredObjects);
+      parent = (IEnvironment)PersistenceManager.Restore(node.SelectSingleNode("ParentEnvironment"), restoredObjects);
     }
     #endregion
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/HeuristicLab.Core-3.2.csproj
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/HeuristicLab.Core-3.2.csproj	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/HeuristicLab.Core-3.2.csproj	(revision 2027)
@@ -126,5 +126,31 @@
     </Compile>
     <Compile Include="AliasEventArgs.cs" />
+    <Compile Include="Interfaces\IVariablesContainer.cs" />
+    <Compile Include="VariablesContainerView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="VariablesContainerView.Designer.cs">
+      <DependentUpon>VariablesContainerView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Parameter.cs" />
+    <Compile Include="OperatorBaseParametersView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="OperatorBaseParametersView.Designer.cs">
+      <DependentUpon>OperatorBaseParametersView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ParameterView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ParameterView.Designer.cs">
+      <DependentUpon>ParameterView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Environment.cs" />
+    <Compile Include="OperatorBaseView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="OperatorBaseView.Designer.cs">
+      <DependentUpon>OperatorBaseView.cs</DependentUpon>
+    </Compile>
     <Compile Include="ParameterEventArgs.cs" />
     <Compile Include="ParameterType.cs" />
@@ -143,16 +169,4 @@
     <Compile Include="NameChangingEventArgs.cs" />
     <Compile Include="OperationEventArgs.cs" />
-    <Compile Include="OperatorBaseVariablesView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="OperatorBaseVariablesView.Designer.cs">
-      <DependentUpon>OperatorBaseVariablesView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="OperatorBaseVariableInfosView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="OperatorBaseVariableInfosView.Designer.cs">
-      <DependentUpon>OperatorBaseVariableInfosView.cs</DependentUpon>
-    </Compile>
     <Compile Include="ExceptionEventArgs.cs" />
     <Compile Include="Interfaces\IConstrainedItem.cs" />
@@ -200,10 +214,4 @@
     <Compile Include="OperatorIndexEventArgs.cs" />
     <Compile Include="ScopeEventArgs.cs" />
-    <Compile Include="OperatorBaseView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="OperatorBaseView.Designer.cs">
-      <DependentUpon>OperatorBaseView.cs</DependentUpon>
-    </Compile>
     <Compile Include="OperatorGraphView.cs">
       <SubType>UserControl</SubType>
@@ -295,14 +303,18 @@
       <SubType>Designer</SubType>
     </EmbeddedResource>
+    <EmbeddedResource Include="OperatorBaseParametersView.resx">
+      <DependentUpon>OperatorBaseParametersView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="VariablesContainerView.resx">
+      <DependentUpon>VariablesContainerView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="ParameterView.resx">
+      <DependentUpon>ParameterView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
     <EmbeddedResource Include="OperatorBaseDescriptionView.resx">
       <DependentUpon>OperatorBaseDescriptionView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="OperatorBaseVariablesView.resx">
-      <DependentUpon>OperatorBaseVariablesView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="OperatorBaseVariableInfosView.resx">
-      <DependentUpon>OperatorBaseVariableInfosView.cs</DependentUpon>
       <SubType>Designer</SubType>
     </EmbeddedResource>
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IEnvironment.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IEnvironment.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IEnvironment.cs	(revision 2027)
@@ -27,4 +27,7 @@
   public interface IEnvironment : IItem {
     string TranslateName(string name);
+
+    void AddAlias(string oldName, string newName);
+    void RemoveAlias(string name);
   }
 }
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IOperator.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IOperator.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IOperator.cs	(revision 2027)
@@ -49,7 +49,28 @@
 
     /// <summary>
+    /// Gets a list of all sub operators.
+    /// </summary>
+    IList<IOperator> SubOperators { get; }
+    /// <summary>
     /// Gets a collection of all variable (parameter) infos.
     /// </summary>
     ICollection<IParameter> Parameters { get; }
+
+    /// <summary>
+    /// Adds the given sub operator to the current instance.
+    /// </summary>
+    /// <param name="op">The operator to add.</param>
+    void AddSubOperator(IOperator op);
+    /// <summary>
+    /// Adds the given sub operator at a the specified <paramref name="index"/>.
+    /// </summary>
+    /// <param name="op">The operator to add.</param>
+    /// <param name="index">The position where to add the operator.</param>
+    void AddSubOperator(IOperator op, int index);
+    /// <summary>
+    /// Removes a sub operator at the specified <paramref name="index"/>.
+    /// </summary>
+    /// <param name="index">The position where to delete the operator.</param>
+    void RemoveSubOperator(int index);
 
     /// <summary>
@@ -75,5 +96,5 @@
     /// <param name="scope">The scope where to execute the current instance.</param>
     /// <returns>The next operation.</returns>
-    IOperation Execute(IEnvironment environment, IScope scope);
+    IOperation Execute(IEnvironment env, IScope scope);
     /// <summary>
     /// Aborts the current operator.
@@ -88,5 +109,13 @@
     /// Occurs when the breakpoint flag of the current instance was changed.
     /// </summary>
-    event EventHandler BreakpointChanged; 
+    event EventHandler BreakpointChanged;
+    /// <summary>
+    /// Occurs when a sub operator has been added.
+    /// </summary>
+    event EventHandler<OperatorIndexEventArgs> SubOperatorAdded;
+    /// <summary>
+    /// Occurs when a sub operator has been deleted.
+    /// </summary>
+    event EventHandler<OperatorIndexEventArgs> SubOperatorRemoved;
     /// <summary>
     /// Occurs when a variable info has been added.
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IScope.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IScope.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IScope.cs	(revision 2027)
@@ -29,5 +29,5 @@
   /// Interface for a hierarchical container of variables (containing variables and subscopes). 
   /// </summary>
-  public interface IScope : IItem {
+  public interface IScope : IItem, IVariablesContainer {
     /// <summary>
     /// Gets the name of the current instance.
@@ -35,8 +35,4 @@
     string Name { get; }
 
-    /// <summary>
-    /// Gets the varibles of the current scope.
-    /// </summary>
-    ICollection<IVariable> Variables { get; }
     /// <summary>
     /// Gets all subscopes in the current scope.
@@ -50,21 +46,4 @@
     void SetParent(IScope scope);
 
-    /// <summary>
-    /// Gets a variable with the given <paramref name="name"/>.
-    /// </summary>
-    /// <param name="name">The name of the variable.</param>
-    /// <returns>The variable with the specified name.</returns>
-    IVariable GetVariable(string name);
-    /// <summary>
-    /// Adds the specified variable to the curent instance.
-    /// </summary>
-    /// <param name="variable">The variable to add.</param>
-    void AddVariable(IVariable variable);
-    /// <summary>
-    /// Deletes a variable with the specified <paramref name="name"/> from the current instance.
-    /// </summary>
-    /// <param name="name">The name of the variable to delete.</param>
-    void RemoveVariable(string name);
-    
     /// <inheritdoc cref="GetVariableValue(string, bool)"/>
     /// <typeparam name="T">The type of the value that is searched.</typeparam>
@@ -125,12 +104,4 @@
 
     /// <summary>
-    /// Occurs when a variable has been added to the current instance.
-    /// </summary>
-    event EventHandler<VariableEventArgs> VariableAdded;
-    /// <summary>
-    /// Occurs when a variable has been deleted from the current instance.
-    /// </summary>
-    event EventHandler<VariableEventArgs> VariableRemoved;
-    /// <summary>
     /// Occurs when a sub scope has been added to the current instance.
     /// </summary>
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IVariablesContainer.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IVariablesContainer.cs	(revision 2027)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/Interfaces/IVariablesContainer.cs	(revision 2027)
@@ -0,0 +1,63 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface for a container of variables.
+  /// </summary>
+  public interface IVariablesContainer : IItem {
+    /// <summary>
+    /// Gets the contained varibles.
+    /// </summary>
+    ICollection<IVariable> Variables { get; }
+
+    /// <summary>
+    /// Gets a variable with the given <paramref name="name"/>.
+    /// </summary>
+    /// <param name="name">The name of the variable.</param>
+    /// <returns>The variable with the specified name.</returns>
+    IVariable GetVariable(string name);
+    /// <summary>
+    /// Adds the specified variable to the curent instance.
+    /// </summary>
+    /// <param name="variable">The variable to add.</param>
+    void AddVariable(IVariable variable);
+    /// <summary>
+    /// Deletes a variable with the specified <paramref name="name"/> from the current instance.
+    /// </summary>
+    /// <param name="name">The name of the variable to delete.</param>
+    void RemoveVariable(string name);
+
+    /// <summary>
+    /// Occurs when a variable has been added to the current instance.
+    /// </summary>
+    event EventHandler<VariableEventArgs> VariableAdded;
+    /// <summary>
+    /// Occurs when a variable has been deleted from the current instance.
+    /// </summary>
+    event EventHandler<VariableEventArgs> VariableRemoved;
+  }
+}
